{******************************************************************************

Copyright 2001-2003 Saulo Popov Zambiasi. All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:

1. Redistributions of source code must retain the above copyright notice,
   this list of conditions and the following disclaimer. 
2. Redistributions in binary form must reproduce the above copyright notice,
   this list of conditions and the following disclaimer in the documentation
   and/or other materials provided with the distribution. 

THIS SOFTWARE IS PROVIDED BY SAULO POPOV ZAMBIASI "AS IS" AND ANY EXPRESS OR
IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
EVENT SHALL SAULO POPOV ZAMBIASI OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY
OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

The views and conclusions contained in the software and documentation are those
of the authors and should not be interpreted as representing official policies,
either expressed or implied, of Saulo Popov Zambiasi.

Copyright 2001-2003 Saulo Popov Zambiasi. All rights reserved.
Last modified: 2003/02/26 20:41:00

******************************************************************************}

UNIT UEleMap;

INTERFACE

USES
   Graph, Mouse, Objects, Collects, Icones,
   Config, MapDB, Devices, Agents, SystemMS;

TYPE
   PElement = ^OElement;
   OElement = Object (TObject)
      on     : Boolean;
      Step   : 0..1;
      icList : OCollection;
      Size   : Byte;
      Sector : Byte;
      Course : SetofCourse;
      icVoid : PIcon;
      Dev    : PDevice;
      MyAgent: PAgent;

      Constructor Init(ix, iy, w, h : Integer; Ms, agType, id : Byte; icv : PIcon; M : PMouse);
      Procedure   PutIcon(ic : PIcon);
      Procedure   Draw; Virtual;
      Procedure   Show; Virtual;
      Procedure   Run; Virtual;
      Destructor  Done;
   End;


IMPLEMENTATION

Constructor OElement.Init(ix, iy, w, h : Integer; MS, agType, id : Byte; icv : PIcon; M : PMouse);

Var
   i : Byte;


Begin
   TObject.Init(ix, iy, w, h, M);
   icList.Init;
   icList.SetFree(False);
   icVoid := icv;

{   Ver o TIPO de agente e inicializar conforme o tipo }

{   New(MyAgent, Init(MS, agType, id, Dev));}
   Size := 0;
   Step := 0;
End;

Procedure OElement.PutIcon(ic : PIcon);
Begin
   icList.InsertItem(ic);
End;

Procedure OElement.Show;
Begin
   TObject.Show;
End;

Procedure OElement.Draw;

Var
   i  : Byte;
   ic : PIcon;

Begin
   { If is on }
   if (Not on) Then i := 0
   Else i := 2+(Step*2);

   { if your course is to right }
   If ((Course = CWRIGHTDOWN) or
       (Course = CWRIGHTUP)   or
       (Course = CWRIGHT))    Then
      i := i+1;

   { if has a icon to put }
   If (icList.GetSize < i) Then
      If ((i-2) >= 0) Then i := i-2;

   { put icon }
   If (icList.GetSize >= i) Then
   Begin
      ic := icList.GetItem(i);
      ic^.X := X;
      ic^.Y := Y-ELEMENTWIDTH;
      ic^.Draw;
   End Else
   Begin
      icVoid^.X := X;
      icVoid^.Y := Y-ELEMENTWIDTH;
      icVoid^.Draw;
   End;
End;

Procedure OElement.Run;
Begin
End;

Destructor OElement.Done;
Begin
   icList.Done;
   TObject.Done;
End;

End.