{******************************************************************************

Copyright 2001-2003 Saulo Popov Zambiasi. All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:

1. Redistributions of source code must retain the above copyright notice,
   this list of conditions and the following disclaimer. 
2. Redistributions in binary form must reproduce the above copyright notice,
   this list of conditions and the following disclaimer in the documentation
   and/or other materials provided with the distribution. 

THIS SOFTWARE IS PROVIDED BY SAULO POPOV ZAMBIASI "AS IS" AND ANY EXPRESS OR
IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
EVENT SHALL SAULO POPOV ZAMBIASI OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY
OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

The views and conclusions contained in the software and documentation are those
of the authors and should not be interpreted as representing official policies,
either expressed or implied, of Saulo Popov Zambiasi.

Copyright 2001-2003 Saulo Popov Zambiasi. All rights reserved.
Last modified: 2003/02/26 20:41:00

******************************************************************************}

{**************************************************

        File : devices.pas
  Developper : Saulo Popov Zambiasi
 Last Update : Feb/14/2002

 That is the program of devices. Each device has a
 different program, but has the same protocoll. If
 Device is a Sensor, then it will just send any
 informations about your detections. If Not, then
 will receive and send informations.

 UPDATE:

    0 - Nothing updated
    1 - Device whas turnned off
    2 - Device whas turnned on
    3 - Level 1 whas changged (consider then is on)
    4 - Level 2 whas changged
    5 - Level 1 and 2 whas changed
    6 - Device Sleep
    7 - Device wake up

**************************************************}


UNIT Devices;

INTERFACE

TYPE
   PDevice = ^ODevice;
   ODevice = Object
      On     : Byte;   { State on|off          }
      Level1 : Byte;   { Value Level 1         }
      Level2 : Byte;   { Value Level 2         }
      Update : Byte;   { Information updated   }
      Command: String; { If voice, command     }
      Change : Boolean;
      Constructor Init;
      Procedure   Run; Virtual;
      Procedure   Show; Virtual;
      Procedure   SetOn(b : Boolean);
      Procedure   SetLevel1(i : Byte);
      Procedure   SetLevel2(i : Byte);
      Procedure   SetComand(cmd : String);
      Function    Changed : Boolean;
      Destructor  Done;
   End;

IMPLEMENTATION

Constructor ODevice.Init;
Begin
   On     := 0;
   Level1 := 0;
   Level2 := 0;
   Update := 0;
   Command:= '';
   Change := False;
End;

Procedure ODevice.SetOn(b : Boolean);
Begin
   on     := Byte(b);
   Update := 1;
   Change := True;
End;

Procedure ODevice.SetLevel1(i : Byte);
Begin
   Level1 := i;
   Update := 1;
   Change := True;
End;

Procedure ODevice.SetLevel2(i : Byte);
Begin
   Level2 := i;
   Update := 1;
   Change := True;
End;

Procedure ODevice.SetComand(cmd : String);
Begin
   Command := cmd;
   Update  := 1;
   Change  := True;
End;

Procedure ODevice.Run;
Begin
End;

Procedure ODevice.Show;
Begin
End;

Function ODevice.Changed;
Begin
   Changed := Change;
   Change  := False;
End;

Destructor ODevice.Done;
Begin
End;

End.