{******************************************************************************

Copyright 2001-2003 Saulo Popov Zambiasi. All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:

1. Redistributions of source code must retain the above copyright notice,
   this list of conditions and the following disclaimer. 
2. Redistributions in binary form must reproduce the above copyright notice,
   this list of conditions and the following disclaimer in the documentation
   and/or other materials provided with the distribution. 

THIS SOFTWARE IS PROVIDED BY SAULO POPOV ZAMBIASI "AS IS" AND ANY EXPRESS OR
IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
EVENT SHALL SAULO POPOV ZAMBIASI OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY
OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

The views and conclusions contained in the software and documentation are those
of the authors and should not be interpreted as representing official policies,
either expressed or implied, of Saulo Popov Zambiasi.

Copyright 2001-2003 Saulo Popov Zambiasi. All rights reserved.
Last modified: 2003/02/26 20:41:00

******************************************************************************}

UNIT MemIcons;

INTERFACE

USES
    Objects, MyMouse, Icones, ImgDB;

TYPE
   PMemIcon = ^OMemIcon;
   OMemIcon = Object (TObject)
      Code    : String[5];
      Level   : Byte;
      icon    : PIcon;

      Constructor Init(iCode : String; iLevel : Byte; M : PMouse);
      Procedure   PutIcon(ic : PIcon);
      Procedure   PutSprite(img : ImgSprite);
      Procedure   Show; Virtual;
      Procedure   Draw; Virtual;
      Procedure   Free; Virtual;
      Procedure   Run; Virtual;
      Destructor  Done;
   End;


IMPLEMENTATION

Constructor OMemIcon.Init(iCode : String; iLevel : Byte; M : PMouse);
Begin
   TObject.Init(0,0,0,0, M);
   Code  := iCode;
   Level := iLevel;
   icon  := nil;
End;

Procedure OMemIcon.PutIcon(ic : PIcon);
Begin
   if (icon <> nil) Then
   Begin
      Dispose(icon, Done);
      icon := Nil;
   End;
   icon := ic;
End;

Procedure OMemIcon.PutSprite(img : ImgSprite);

Var
   i, j, a : Integer;

Begin
   If (icon <> nil) Then
   Begin
      Dispose(Icon, Done);
      Icon := Nil;
   End;

   New(Icon, Init(1, 1, 16, 32, Pointer));
   a := 1;
   For j := 1 To 32 Do
      For i := 1 To 16 Do
      Begin
         Icon^.PutPixelColor(i, j, img[a]);
         a := a + 1;
      End;
End;

Procedure OMemIcon.Run;
Begin
End;

Procedure OMemIcon.Draw;
Begin
End;

Procedure OMemIcon.Show;
Begin
End;

Procedure OMemIcon.Free;
Begin
   If (icon <> Nil) Then
   Begin
      Dispose(Icon, Done);
      Icon := Nil;
   End;
End;

Destructor OMemIcon.Done;
Begin
   If (icon <> Nil) Then
      Dispose(Icon, Done);
   TObject.Done;
End;

End.