{******************************************************************************

Copyright 2001-2003 Saulo Popov Zambiasi. All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:

1. Redistributions of source code must retain the above copyright notice,
   this list of conditions and the following disclaimer. 
2. Redistributions in binary form must reproduce the above copyright notice,
   this list of conditions and the following disclaimer in the documentation
   and/or other materials provided with the distribution. 

THIS SOFTWARE IS PROVIDED BY SAULO POPOV ZAMBIASI "AS IS" AND ANY EXPRESS OR
IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
EVENT SHALL SAULO POPOV ZAMBIASI OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY
OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

The views and conclusions contained in the software and documentation are those
of the authors and should not be interpreted as representing official policies,
either expressed or implied, of Saulo Popov Zambiasi.

Copyright 2001-2003 Saulo Popov Zambiasi. All rights reserved.
Last modified: 2003/02/26 20:41:00

******************************************************************************}

{**********************************************

       File : samples.pas
 Developper : Saulo Popov Zambiasi
Last Update : Feb/15/2002

**********************************************}

UNIT Strove;

INTERFACE

USES
   LowLevel, Msg, Agents, Devices, MapDB;

TYPE

   PStrove = ^OStrove;
   OStrove = Object (OAgent)
      Grease  : Byte;
      Constructor Init(MS, AgType, Address : Byte; Dv : PDevice);
      Procedure   Run; Virtual;
      Procedure   Stop; Virtual;
      Destructor  Done;
   End;

IMPLEMENTATION

Constructor OStrove.Init(MS, AgType, Address : Byte; Dv : PDevice);
Begin
   OAgent.Init(Ms, AgType, Address, Dv);
   Grease := 0;
End;

{**************************************************

   Run the opearations of Strove Agent

**************************************************}

Procedure OStrove.Run;

Var
   Mesg : Message;

Begin
   OAgent.Run;

   If (Not MesgLoaded) Then
   Begin
      GetBufferMesg(Mesg);

      If (Mesg <> 'NULL') Then
      Begin
         { If message is a voice command then execute}
         if (Mesg[MESG_TP] = 'C') Then
         Begin
            If (Mesg[CMD_ON]     <> #255) Then On     := Ord(Mesg[CMD_ON]);
            If (Mesg[CMD_LEVEL1] <> #255) Then Level1 := Ord(Mesg[CMD_LEVEL1]);
            If (Mesg[CMD_LEVEL2] <> #255) Then Level2 := Ord(Mesg[CMD_LEVEL2]);
            SetDevice;
            Dev^.Update := 1;
            NextBufferMesg;
         End
         { Else if message if anything else, then discard }
         Else NextBufferMesg;
      End;
   End;
   If (On = 1) Then
   Begin
      If (Grease <= 100) Then Grease := Grease + 1;
      If (Grease = 100) Then { Informa que ah gordura }
         MesgOut := MyID + Chr(Id[1]) + Chr(UNIT_GREASE) + #255 + 'C' + #1#255#255#255#255;
   End Else Begin
      If (Grease >= 1) Then Grease := Grease -1;
      If (Grease = 1) Then { Informa que nao ha mais gordura }
         MesgOut := MyID + Chr(Id[1]) + Chr(UNIT_GREASE) + #255 + 'C' + #0#255#255#255#255;
   End;

   Stop;
End;

{**************************************************

 Execute last functions to finich that moment task

***************************************************}

Procedure OStrove.Stop;
Begin
   OAgent.Stop;
End;

Destructor OStrove.Done;
Begin
   OAgent.Done;
End;

End.