{******************************************************************************

Copyright 2001-2003 Saulo Popov Zambiasi. All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:

1. Redistributions of source code must retain the above copyright notice,
   this list of conditions and the following disclaimer. 
2. Redistributions in binary form must reproduce the above copyright notice,
   this list of conditions and the following disclaimer in the documentation
   and/or other materials provided with the distribution. 

THIS SOFTWARE IS PROVIDED BY SAULO POPOV ZAMBIASI "AS IS" AND ANY EXPRESS OR
IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
EVENT SHALL SAULO POPOV ZAMBIASI OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY
OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

The views and conclusions contained in the software and documentation are those
of the authors and should not be interpreted as representing official policies,
either expressed or implied, of Saulo Popov Zambiasi.

Copyright 2001-2003 Saulo Popov Zambiasi. All rights reserved.
Last modified: 2003/02/26 20:41:00

******************************************************************************}

UNIT Strs;

INTERFACE

TYPE

   PNStr = ^NStr;
   NStr  = Record
      Next : PNstr;
      Item : String;
   End;

   PStr = ^OStr;
   OStr = Object
   Private
      Size  : Integer;
      First : PNStr;
      Select: PNStr;
   Public
       Constructor Init;
       Procedure   Add(tx : String);
       Function    Get(index : Integer) : String;
       Function    GetSize : Integer;
       Procedure   Free; Virtual;
       Destructor  Done;
   End;

IMPLEMENTATION

Constructor OStr.Init;
Begin
   First  := Nil;
   Select := Nil;
   Size   := 0;
End;

Procedure OStr.Add(tx : String);

Var
  Pont : PNStr;
  Prev : PNStr;
  Vazio: Boolean;

Begin
   Inc(Size);
   Vazio := True;
   Pont  := First;
   Prev  := Pont;
   While Pont <> Nil Do
   Begin
      Prev := Pont;
      Pont := Pont^.Next;
      Vazio:= False;
   End;
   New(Pont);
   Pont^.Item := tx;
   Pont^.Next := Nil;
   If Not Vazio Then
      Prev^.Next := Pont
   Else
   Begin
      First := Pont;
      Select := First;
   End;
End;


Function OStr.Get(index : Integer) : String;

Var
   Pont : PNStr;
   item : String;
   i    : Integer;

Begin
   Item := 'NULL';
   Pont:= First;
   i   := 1;
   While (i <= Index) and (Pont <> Nil) Do
   Begin
      If i = Index Then
         Item := Pont^.Item;
      Pont := Pont^.Next;
      Inc(i);
   End;
   Get := Item;
End;

Function OStr.GetSize : Integer;
Begin
   GetSize := Size;
End;

Procedure OStr.Free;

Var
   Pont : PNStr;

Begin
   Size := 0;
   While (First <> Nil) Do
   Begin
      Pont := First;
      First := First^.Next;
      Dispose(Pont);
   End;
End;


Destructor OStr.Done;

Var
   Pont : PNStr;

Begin
   While (First <> Nil) Do
   Begin
      Pont := First;
      First := First^.Next;
      Dispose(Pont);
   End;
End;

End.