{******************************************************************************

Copyright 2001-2003 Saulo Popov Zambiasi. All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:

1. Redistributions of source code must retain the above copyright notice,
   this list of conditions and the following disclaimer. 
2. Redistributions in binary form must reproduce the above copyright notice,
   this list of conditions and the following disclaimer in the documentation
   and/or other materials provided with the distribution. 

THIS SOFTWARE IS PROVIDED BY SAULO POPOV ZAMBIASI "AS IS" AND ANY EXPRESS OR
IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
EVENT SHALL SAULO POPOV ZAMBIASI OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY
OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

The views and conclusions contained in the software and documentation are those
of the authors and should not be interpreted as representing official policies,
either expressed or implied, of Saulo Popov Zambiasi.

Copyright 2001-2003 Saulo Popov Zambiasi. All rights reserved.
Last modified: 2003/02/26 20:41:00

******************************************************************************}

UNIT UGetFile;

INTERFACE

Uses
   Graph, Crt, MyMouse, Button, Rolls,
   Boxs, TextBoxs, RollBoxs, Objects,
   Labels, Config, SysUtils;

TYPE
   PGetFile = ^OGetFile;
   OGetFile = Object (OBox)
      FileName : Str12;
      RollFile : ORollBox;
      btclick  : TypeButtons;
      Title    : String;
      btOk     : OButton;
      btCancel : OButton;

      Constructor Init(ix, iy, h : Integer; tit, T : String; M : PMouse);
      Procedure   Run; Virtual;
      Procedure   Show; Virtual;
      Procedure   Draw; Virtual;
      Destructor  Done;
   End;

IMPLEMENTATION

Constructor OGetFile.Init(ix, iy, h : Integer; tit, T : String; M : PMouse);

Var
   i : Integer;
   DirInfo : TSearchRec;

Begin
   btclick := NONE;
   Title   := tit;
   OBox.Init(ix, iy, 27+(20*8), 65+(h*15), True, Title, True, M);
   RollFile.Init(x+5, y+20, 19, h, T, M);

   if (FindFirst(T, faAnyFile, DirInfo) = 0) Then
   Begin
      Repeat
         RollFile.Add(DirInfo.Name);
      until FindNext(DirInfo) <> 0;
      FindClose(DirInfo);
   End;

   i := (Width-140) Div 3;
   btOk.Init    (x+i,        y+Height-20, 70, 15, 'Confirma', M);
   btCancel.Init(x+(i*2)+70, y+Height-20, 70, 15, 'Cancela', M);

   OBox.Draw;
   RollFile.Draw;
   btOk.Draw;
   btCancel.Draw;
End;

Procedure OGetFile.Run;
Begin
   Repeat
      OBox.Run;
      RollFile.Run;
      btOk.Run;
      btCancel.Run;
      ScreenShow;
      If (RollFile.Selected) Then
      Begin
         FileName := RollFile.TextSelect;
         RollFile.Text := FileName;
         RollFile.Draw;
      End;
      If (btOk.Selected) Then btClick := OK;
      If (btCancel.Selected) Then btClick := CANCEL;
   Until (btClick <> NONE);
End;

Procedure OGetFile.Show;
Begin
   OBox.Show;
End;

Procedure OGetFile.Draw;
Begin
   OBox.Draw;
End;

Destructor OGetFile.Done;
Begin
   btCancel.Done;
   btOk.Done;
   RollFile.Done;
   OBox.Done;
End;

End.
