{******************************************************************************

Copyright 2001-2003 Saulo Popov Zambiasi. All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:

1. Redistributions of source code must retain the above copyright notice,
   this list of conditions and the following disclaimer. 
2. Redistributions in binary form must reproduce the above copyright notice,
   this list of conditions and the following disclaimer in the documentation
   and/or other materials provided with the distribution. 

THIS SOFTWARE IS PROVIDED BY SAULO POPOV ZAMBIASI "AS IS" AND ANY EXPRESS OR
IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
EVENT SHALL SAULO POPOV ZAMBIASI OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY
OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

The views and conclusions contained in the software and documentation are those
of the authors and should not be interpreted as representing official policies,
either expressed or implied, of Saulo Popov Zambiasi.

Copyright 2001-2003 Saulo Popov Zambiasi. All rights reserved.
Last modified: 2003/02/26 20:41:00

******************************************************************************}

Unit graph;

INTERFACE

Uses
   chars, alpgraph, ag_sdl;

Var
   graph_color   : Byte;
   graph_bkcolor : Byte;

Procedure InitGraph(WindowName : String; f : boolean);
Procedure PutPixel(x, y, c : Integer);
Function  GetPixel(x, y : Integer) : Byte;
Procedure Line(x1, y1, x2, y2 : Integer);
Procedure SetColor(c : Byte);
Procedure SetBkColor(c : Byte);
Procedure ClearDevice;
Procedure OutTextXY(x, y : Integer; Tx : String);
Procedure ScreenShow;
Procedure CloseGraph;

IMPLEMENTATION

Procedure InitGraph(WindowName : String; f : Boolean);
Begin
   AGInit(640,480,8,WindowName, f, false);
End;

Procedure PutPixel(x, y, c : Integer);
Begin
   alpgraph.PutPixel(screen, x, y, c);
End;

Function GetPixel(x, y : Integer) : Byte;
Begin
   GetPixel := Byte(alpgraph.GetPixel(screen, x, y));
End;

Procedure Line(x1, y1, x2, y2 : Integer);
Begin
   DrawLine(screen, x1, y1, x2, y2, graph_color);
End;

Procedure SetColor(c : Byte);
Begin
   graph_color := c;
End;

Procedure SetBkColor(c : Byte);
Begin
   graph_bkcolor := c;
End;

Procedure ClearDevice;
Begin
   DrawFilledRectangle(screen, 0, 0, 640, 480, 0);
End;

Procedure OutTextXY(x, y : Integer; Tx : String);
Begin
   DrawStr(screen, (@charset8x8)^, x, y, Tx, graph_color,
           graph_bkcolor, false, 8, 8);
End;

Procedure ScreenShow;
Begin
   Update(0,0,0,0);
End;

Procedure CloseGraph;
Begin
   AGDone;
End;

Begin
   graph_color   := 0;
   graph_bkcolor := 0;
End.
