{******************************************************************************

Copyright 2001-2003 Saulo Popov Zambiasi. All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:

1. Redistributions of source code must retain the above copyright notice,
   this list of conditions and the following disclaimer. 
2. Redistributions in binary form must reproduce the above copyright notice,
   this list of conditions and the following disclaimer in the documentation
   and/or other materials provided with the distribution. 

THIS SOFTWARE IS PROVIDED BY SAULO POPOV ZAMBIASI "AS IS" AND ANY EXPRESS OR
IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
EVENT SHALL SAULO POPOV ZAMBIASI OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY
OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

The views and conclusions contained in the software and documentation are those
of the authors and should not be interpreted as representing official policies,
either expressed or implied, of Saulo Popov Zambiasi.

Copyright 2001-2003 Saulo Popov Zambiasi. All rights reserved.
Last modified: 2003/02/26 20:41:00

******************************************************************************}

UNIT wstatus;

INTERFACE

USES
   Objects, MyMouse, Graph, Config;

TYPE
   TypeButtons = (NONE, OK, CANCEL);

   PButton = ^OButton;
   OButton = Object (TObject)
      Text      : String;
      Code      : Byte;
      Select    : Boolean;
      Pressed   : Boolean;
      btClick   : TypeButtons;

      Constructor Init(ix, iy, w, h : Integer; Tx : String; M : PMouse);
      Procedure   Show; Virtual;
      Procedure   Draw; Virtual;
      Procedure   Run; Virtual;
      Function    Selected : Boolean;
      Destructor  Done;
   End;

IMPLEMENTATION

Constructor OButton.Init(ix, iy, w, h : Integer; Tx : String; M : PMouse);

Begin
   TObject.Init(ix, iy, w, h, M);
   Text      := Tx;
   Align     := CENTER;
   btClick   := NONE;
   Visible   := True;
   Select    := False;
   Pressed   := False;
   Code      := 0;
End;

Procedure OButton.Draw;

Var
   tx, ty : Integer;
   size   : Integer;
   txaux  : String;

Begin
   Pointer^.Show(False);
   SetColor(Border);
   Line(x, y, x+Width, y);
   Line(x, y+Height, x+Width, y+Height);
   Line(x, y+1, x, y+Height-1);
   Line(x+Width, y+1, x+Width, y+Height-1);

   If (InRange and Active) Then SetColor(Backon)
   Else SetColor(Backoff);

   For ty := y+1 To y+Height-1 Do
      Line(x+1, ty, x+Width-1, ty);

   ty    := y + (((y+Height - y) div 2) - 3);

   SetColor(TxColor);

   If (Length(Text)*8 > Width-2) Then
      txaux := Copy(Text, 1, ((Width-2) Div 8))
   Else txaux := Text;

   Size := Length(txaux);

   Case (Align) of
      LEFT   : tx := x + 2;
      RIGHT  : tx := (x+Width - 2) - Size*8;
      CENTER : tx := x + ((x+Width - x) Div 2) - ((Size*8) Div 2);
      Else tx := x + 2;
   End;

   OutTextXY(tx, ty, Txaux);
   Pointer^.Show(True);
End;

Procedure OButton.Show;
Begin
   TObject.Show;
End;


Procedure OButton.Run;
Begin
   If (Visible) Then Show;

   If (Active and InRange) Then
   Begin
      If (Pointer^.Press) Then
      Begin
         If (Not Pressed) Then
         Begin
            Pressed := True;
            Select  := True;
         End;
      End Else Pressed := False;
   End Else Pressed := False;
End;

Function OButton.Selected : Boolean;

Begin
   Selected := Select;
   Select   := False;
End;

Destructor OButton.Done;

Begin
   TObject.Done;
End;

End.
